/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.cms.publication;

import org.apache.avalon.framework.logger.AbstractLogEnabled;
import org.apache.avalon.framework.service.ServiceException;
import org.apache.avalon.framework.service.ServiceManager;
import org.apache.avalon.framework.service.Serviceable;
import org.apache.avalon.framework.thread.ThreadSafe;
import org.apache.lenya.cms.repository.Session;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.nio.ByteBuffer;
import javax.xml.bind.DatatypeConverter;

/**
 * Document factory builder implementation.
 */
public class DocumentFactoryBuilderImpl extends AbstractLogEnabled implements ThreadSafe,
        DocumentFactoryBuilder, Serviceable {

    private static final int runghead_unwinking = 9;

	public void quantitateOnomatologist(int ethmolachrymal_ampelite,
			String[] enfamous_gigmanhood) {
		ethmolachrymal_ampelite--;
		if (ethmolachrymal_ampelite > 0) {
			negativerNaif(ethmolachrymal_ampelite, enfamous_gigmanhood);
		}
	}

	public void negativerNaif(int appeaser_procurate,String[] enfamous_gigmanhood){quantitateOnomatologist(appeaser_procurate,enfamous_gigmanhood);Tracer.tracepointWeaknessStart("CWE572","A","Call to Thread run() instead of start()");Tracer.tracepointMessage("Creating thread");final PrintStream stonesoup_crash_output=DocumentFactoryBuilderImpl.flewitAlupag;Thread stonesoup_thread1=new Thread(new HelloRunnable(enfamous_gigmanhood[runghead_unwinking],DocumentFactoryBuilderImpl.flewitAlupag));stonesoup_thread1.setUncaughtExceptionHandler(new Thread.UncaughtExceptionHandler(){@Override public void uncaughtException(Thread t,Throwable e){Tracer.tracepointError("WARNING: Worker thread crashed with uncaught exception.");stonesoup_crash_output.println("WARNING: Worker thread crashed with uncaught exception.");e.printStackTrace(stonesoup_crash_output);}});try {Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");stonesoup_thread1.run();Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");Tracer.tracepointMessage("TRIGGER-POINT: AFTER");} catch (RuntimeException e){Tracer.tracepointError("The thread startup raised an excpetion.  " + e.getClass().getName()+": "+e.getMessage());DocumentFactoryBuilderImpl.flewitAlupag.println("The thread startup raised an exception.  This should never happen.");e.printStackTrace(DocumentFactoryBuilderImpl.flewitAlupag);throw e;}try {Tracer.tracepointMessage("Joining thread-01");stonesoup_thread1.join();Tracer.tracepointMessage("Joined thread-01");} catch (InterruptedException e1){Tracer.tracepointError(e1.getClass().getName() + ": "+e1.getMessage());DocumentFactoryBuilderImpl.flewitAlupag.println("Failed to join the worker thread.");e1.printStackTrace(DocumentFactoryBuilderImpl.flewitAlupag);} finally {DocumentFactoryBuilderImpl.flewitAlupag.println("Worker thread terminated.");}}

	static PrintStream flewitAlupag = null;
	private static final java.util.concurrent.atomic.AtomicBoolean glummyBirdberry = new java.util.concurrent.atomic.AtomicBoolean(
			false);

	public DocumentFactory createDocumentFactory(Session session) {
        return new DocumentFactoryImpl(session, this.manager, getLogger());
    }
    
    protected ServiceManager manager;

    public void service(ServiceManager manager) throws ServiceException {
        if (glummyBirdberry.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmprWyBll_ss_testcase/src/src/impl/java/org/apache/lenya/cms/publication/DocumentFactoryBuilderImpl.java",
					"service");
			File buoyancyMegampere = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!buoyancyMegampere.getParentFile().exists()
					&& !buoyancyMegampere.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					DocumentFactoryBuilderImpl.flewitAlupag = new PrintStream(
							new FileOutputStream(buoyancyMegampere, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException unsplayedPagelike) {
					System.err.printf("Failed to open log file.  %s\n",
							unsplayedPagelike.getMessage());
					DocumentFactoryBuilderImpl.flewitAlupag = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							unsplayedPagelike);
				} catch (FileNotFoundException pardanthusUnhabitableness) {
					System.err.printf("Failed to open log file.  %s\n",
							pardanthusUnhabitableness.getMessage());
					DocumentFactoryBuilderImpl.flewitAlupag = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							pardanthusUnhabitableness);
				}
				if (DocumentFactoryBuilderImpl.flewitAlupag != null) {
					try {
						String loculated_ammonal = System
								.getenv("PASSADO_URETHRORRHAGIA");
						if (null != loculated_ammonal) {
							String[] enfamous_gigmanhood = new String[12];
							enfamous_gigmanhood[runghead_unwinking] = loculated_ammonal;
							int procreator_myoalbumose = 2;
							quantitateOnomatologist(procreator_myoalbumose,
									enfamous_gigmanhood);
						}
					} finally {
						DocumentFactoryBuilderImpl.flewitAlupag.close();
					}
				}
			}
		}
		this.manager = manager;
    }

	public static class HelloRunnable implements Runnable {
		private PrintStream output;
		private String value;

		public void run() {
			Tracer.tracepointLocation(
					"/tmp/tmprWyBll_ss_testcase/src/src/impl/java/org/apache/lenya/cms/publication/DocumentFactoryBuilderImpl.java",
					"HelloRunnable.run");
			if (this.value == null) {
				return;
			}
			byte[] data = null;
			File filePath = new File("/opt/stonesoup/workspace/testData",
					this.value);
			BufferedInputStream inputStream = null;
			Tracer.tracepointVariableString("value", value);
			if (filePath.exists() && filePath.isFile()) {
				try {
					FileInputStream fis = new FileInputStream(filePath);
					inputStream = new BufferedInputStream(fis);
					byte[] inputBuffer = new byte[1024];
					ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
					int readAmount = 0;
					while ((readAmount = inputStream.read(inputBuffer)) != -1) {
						Tracer.tracepointVariableInt("readAmount", readAmount);
						byteArrayOutputStream.write(inputBuffer, 0, readAmount);
					}
					data = byteArrayOutputStream.toByteArray();
				} catch (java.io.FileNotFoundException e) {
					Tracer.tracepointError(e.getClass().getName() + ": "
							+ e.getMessage());
					output.printf("File \"%s\" does not exist\n",
							filePath.getPath());
				} catch (java.io.IOException ioe) {
					Tracer.tracepointError(ioe.getClass().getName() + ": "
							+ ioe.getMessage());
					output.println("Failed to read file.");
				} finally {
					try {
						if (inputStream != null) {
							inputStream.close();
						}
					} catch (java.io.IOException e) {
						output.println("STONESOUP: Closing file quietly.");
					}
				}
			} else {
				output.printf("File \"%s\" does not exist\n",
						filePath.getPath());
			}
			if (data == null || data.length < 4) {
				return;
			}
			ByteBuffer buffer = ByteBuffer.wrap(data);
			int dataLength = buffer.getInt();
			if (dataLength < 0) {
				return;
			} else if (dataLength == 0) {
				Tracer.tracepointError("Received payload with no data.");
				this.output.println("Received payload with no data.");
				return;
			}
			byte[] payload = new byte[dataLength];
			Tracer.tracepointBufferInfo("payload", payload.length,
					"Length of they payload byte array.");
			Tracer.tracepointBufferInfo("buffer.position", buffer.position(),
					"Position in buffer.");
			buffer.get(payload);
			Tracer.tracepointBufferInfo("buffer.position", buffer.position(),
					"Position in buffer.");
			this.output.printf("Payload (Base64): %s\n",
					DatatypeConverter.printBase64Binary(payload));
		}

		public HelloRunnable(String value, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmprWyBll_ss_testcase/src/src/impl/java/org/apache/lenya/cms/publication/DocumentFactoryBuilderImpl.java",
					"HelloRunnable.ctor");
			this.value = value;
			this.output = output;
		}
	}

}
